DATASET_NAME = 'Bird6';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Butterfly7';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Flower17';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Sport8';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Scene15';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'LandUse21';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Flower102';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Caltech101';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Indoor67';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Pet37';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\ORIG\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\ORIG\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Aircraft100';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\BBOXR\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\BBOXR\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

DATASET_NAME = 'Bird200';
DESCRIPTOR_PATH1 = ['C:\data\descriptors\RSIFT\' DATASET_NAME '\BBOXR\6_12_300'];
DESCRIPTOR_PATH2 = ['C:\data\descriptors\MSIFT2\' DATASET_NAME '\BBOXR\6_12_300'];
FORMAT = '*.mat';

IND1 = [3, 2, 1, 0, 7, 6, 5, 4, 11, 10, 9, 8, 15, 14, 13, 12] + 1;
IND2 = [4, 3, 2, 1, 0, 7, 6, 5] + 1;

if (~isdir(DESCRIPTOR_PATH2))
    mkdir(DESCRIPTOR_PATH2);
end
categoryDirectories = dir(DESCRIPTOR_PATH1);
count = 0;
for i = 1: 1: length(categoryDirectories)
    categoryName = categoryDirectories(i).name;
    if (~strcmp(categoryName, '.') && ~strcmp(categoryName, '..'))
        fprintf('Category: %s.\n', categoryName);
        descriptorDirectory1 = fullfile(DESCRIPTOR_PATH1, categoryName);
        descriptorFiles = dir(fullfile(descriptorDirectory1, FORMAT));
        descriptorDirectory2 = fullfile(DESCRIPTOR_PATH2, categoryName);
        if (~isdir(descriptorDirectory2))
            mkdir(descriptorDirectory2);
        end
        c = 0;
        for j = 1: 1: length(descriptorFiles)
            [~, ~, ext] = fileparts(descriptorFiles(j).name);
            if (~strcmp(ext, '.') && ~strcmp(ext, '..') && ~strcmp(ext, '.db'))
                c = c + 1;
                count = count + 1;
                descriptorFile1 = fullfile(descriptorDirectory1, descriptorFiles(j).name);
                descriptorFile2 = fullfile(descriptorDirectory2, descriptorFiles(j).name);
                SIFT = load(descriptorFile1);
                SIFT = SIFT.SIFT;
                desc1 = SIFT.d;
                desc2 = reshape(desc1, [size(SIFT.d, 1), 8, 16]);
                desc2 = desc2(:, IND2, IND1);
                desc2 = reshape(desc2, [size(SIFT.d, 1), 128]);
                for l = 1: 1: size(SIFT.d, 1)
                    for v = 1: 1: 128
                        if (desc1(l, v) > desc2(l, v))
                            SIFT.d(l, :) = desc1(l, :);
                            break;
                        elseif (desc2(l, v) > desc1(l, v))
                            SIFT.d(l, :) = desc2(l, :);
                            break;
                        end
                    end
                end
                save(descriptorFile2, 'SIFT');
                fprintf('    Image No. %04d is finished.\n', c);
            end
        end
    end
end
fprintf('%d images in total.\n', count);

